<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { getClient } from '../plugins/contentful';
import { CONTENT_TYPES } from '../common/content-types';
import LinkCard from '@/components/update/link-card.vue';
import { getPageMetadata } from '~/common/meta';
import { convertToCaseSensitiveLocale } from '~/common/util';

export default Vue.extend({
  components: {
    LinkCard,
  },
  async asyncData({ i18n }) {
    try {
      const { items } = await getClient().getEntries({
        content_type: CONTENT_TYPES.PAGE,
        'sys.id': 'MFgweU088THFizSgoNlgo',
        include: 10,
        locale: convertToCaseSensitiveLocale(i18n.locale),
      });

      const data = items[0].fields.pageContent;
      const metadata = items[0].fields.seoMetadata[0].fields;
      const doc = { ...metadata } as any;
      const [hero, cards] = data;

      //  Data Mapping

      //  Hero:
      doc.heading = {
        header: hero.fields.title,
        subtitle: hero.fields.description,
      };

      // Cards

      doc.cards = cards.fields.card.map((card: any) => ({
        title: card.fields.title,
        description: card.fields.description,
        icon: {
          use_local_icon: true,
          name: card.fields.image.fields.file.url,
          alt: `${card.fields.title} Icon`,
        },
        url: card.fields.cardLink,
        data_ga_name: card.fields.title,
        data_ga_location: 'Update',
      }));

      return { doc };
    } catch (e) {
      throw new Error(e);
    }
  },
  head(): MetaInfo {
    return getPageMetadata(
      (this as any).doc,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
    );
  },
});
</script>

<template>
  <SlpContainer class="update">
    <SlpTypography tag="h1" variant="heading1-bold">{{
      doc.heading.header
    }}</SlpTypography>
    <SlpTypography variant="heading4">
      <div
        v-if="doc.heading.subtitle"
        class="slp-mb-64"
        v-html="$md.render(doc.heading.subtitle)"
      ></div>
    </SlpTypography>

    <div class="cards">
      <LinkCard v-for="card in doc.cards" :key="card.title" :card="card" />
    </div>
  </SlpContainer>
</template>

<style lang="scss" scoped>
.update {
  h1 {
    margin-bottom: $spacing-16;
  }
}
.cards {
  display: flex;
  flex-wrap: wrap;
  justify-content: flex-start;
  gap: $spacing-32;
  align-items: stretch;
  margin-bottom: $spacing-32;

  @media (max-width: $breakpoint-md) {
    gap: $spacing-8;
  }
}
</style>
